{
  "swagger": "2.0",
  "schemes": [
    "https"
  ],
  "host": "management.azure.com",
  "info": {
    "description": "The Azure Storage Management API.",
    "title": "StorageManagementClient",
    "version": "2019-04-01",
    "x-apisguru-categories": [
      "cloud"
    ],
    "x-logo": {
      "url": "https://api.apis.guru/v2/cache/logo/https_assets.onestore.ms_cdnfiles_onestorerolling-1606-01000_shell_v3_images_logo_microsoft.png"
    },
    "x-origin": [
      {
        "format": "swagger",
        "url": "https://raw.githubusercontent.com/Azure/azure-rest-api-specs/master/specification/storage/resource-manager/Microsoft.Storage/stable/2019-04-01/file.json",
        "version": "2.0"
      }
    ],
    "x-preferred": false,
    "x-providerName": "azure.com",
    "x-serviceName": "storage-file",
    "x-tags": [
      "Azure",
      "Microsoft"
    ]
  },
  "consumes": [
    "application/json"
  ],
  "produces": [
    "application/json"
  ],
  "securityDefinitions": {
    "azure_auth": {
      "authorizationUrl": "https://login.microsoftonline.com/common/oauth2/authorize",
      "description": "Azure Active Directory OAuth2 Flow",
      "flow": "implicit",
      "scopes": {
        "user_impersonation": "impersonate your user account"
      },
      "type": "oauth2"
    }
  },
  "security": [
    {
      "azure_auth": [
        "user_impersonation"
      ]
    }
  ],
  "parameters": {
    "FileServicesName": {
      "description": "The name of the file Service within the specified storage account. File Service Name must be \"default\"",
      "enum": [
        "default"
      ],
      "in": "path",
      "name": "FileServicesName",
      "required": true,
      "type": "string",
      "x-ms-parameter-location": "method"
    },
    "ShareName": {
      "description": "The name of the file share within the specified storage account. File share names must be between 3 and 63 characters in length and use numbers, lower-case letters and dash (-) only. Every dash (-) character must be immediately preceded and followed by a letter or number.",
      "in": "path",
      "maxLength": 63,
      "minLength": 3,
      "name": "shareName",
      "required": true,
      "type": "string",
      "x-ms-parameter-location": "method"
    }
  },
  "paths": {
    "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/fileServices": {
      "get": {
        "description": "List all file services in storage accounts",
        "operationId": "FileServices_List",
        "parameters": [
          {
            "description": "The name of the resource group within the user's subscription. The name is case insensitive.",
            "in": "path",
            "maxLength": 90,
            "minLength": 1,
            "name": "resourceGroupName",
            "pattern": "^[-\\w\\._\\(\\)]+$",
            "required": true,
            "type": "string",
            "x-ms-parameter-location": "method"
          },
          {
            "description": "The name of the storage account within the specified resource group. Storage account names must be between 3 and 24 characters in length and use numbers and lower-case letters only.",
            "in": "path",
            "maxLength": 24,
            "minLength": 3,
            "name": "accountName",
            "required": true,
            "type": "string",
            "x-ms-parameter-location": "method"
          },
          {
            "description": "The API version to use for this operation.",
            "in": "query",
            "minLength": 1,
            "name": "api-version",
            "required": true,
            "type": "string"
          },
          {
            "description": "The ID of the target subscription.",
            "in": "path",
            "minLength": 1,
            "name": "subscriptionId",
            "required": true,
            "type": "string"
          }
        ],
        "responses": {
          "200": {
            "description": "OK -- List file services operation completed successfully.",
            "schema": {
              "$ref": "#/definitions/FileServiceItems"
            }
          },
          "default": {
            "description": "Error response describing why the operation failed.",
            "schema": {
              "$ref": "#/definitions/CloudError"
            }
          }
        },
        "tags": [
          "FileService"
        ],
        "x-ms-examples": {
          "ListFileServices": {
            "parameters": {
              "accountName": "sto1590",
              "api-version": "2019-04-01",
              "monitor": "true",
              "resourceGroupName": "res9290",
              "subscriptionId": "{subscription-id}"
            },
            "responses": {
              "200": {
                "body": {
                  "value": [
                    {
                      "id": "/subscriptions/{subscription-id}/resourceGroups/res4410/providers/Microsoft.Storage/storageAccounts/sto8607/fileServices/default",
                      "name": "default",
                      "properties": {
                        "cors": {
                          "corsRules": [
                            {
                              "allowedHeaders": [
                                "x-ms-meta-abc",
                                "x-ms-meta-data*",
                                "x-ms-meta-target*"
                              ],
                              "allowedMethods": [
                                "GET",
                                "HEAD",
                                "POST",
                                "OPTIONS",
                                "MERGE",
                                "PUT"
                              ],
                              "allowedOrigins": [
                                "http://www.contoso.com",
                                "http://www.fabrikam.com"
                              ],
                              "exposedHeaders": [
                                "x-ms-meta-*"
                              ],
                              "maxAgeInSeconds": 100
                            },
                            {
                              "allowedHeaders": [
                                "*"
                              ],
                              "allowedMethods": [
                                "GET"
                              ],
                              "allowedOrigins": [
                                "*"
                              ],
                              "exposedHeaders": [
                                "*"
                              ],
                              "maxAgeInSeconds": 2
                            },
                            {
                              "allowedHeaders": [
                                "x-ms-meta-12345675754564*"
                              ],
                              "allowedMethods": [
                                "GET",
                                "PUT"
                              ],
                              "allowedOrigins": [
                                "http://www.abc23.com",
                                "https://www.fabrikam.com/*"
                              ],
                              "exposedHeaders": [
                                "x-ms-meta-abc",
                                "x-ms-meta-data*",
                                "x-ms-meta-target*"
                              ],
                              "maxAgeInSeconds": 2000
                            }
                          ]
                        }
                      },
                      "type": "Microsoft.Storage/storageAccounts/fileServices"
                    }
                  ]
                }
              }
            }
          }
        }
      }
    },
    "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/fileServices/default/shares": {
      "get": {
        "description": "Lists all shares.",
        "operationId": "FileShares_List",
        "parameters": [
          {
            "description": "The name of the resource group within the user's subscription. The name is case insensitive.",
            "in": "path",
            "maxLength": 90,
            "minLength": 1,
            "name": "resourceGroupName",
            "pattern": "^[-\\w\\._\\(\\)]+$",
            "required": true,
            "type": "string",
            "x-ms-parameter-location": "method"
          },
          {
            "description": "The name of the storage account within the specified resource group. Storage account names must be between 3 and 24 characters in length and use numbers and lower-case letters only.",
            "in": "path",
            "maxLength": 24,
            "minLength": 3,
            "name": "accountName",
            "required": true,
            "type": "string",
            "x-ms-parameter-location": "method"
          },
          {
            "description": "The API version to use for this operation.",
            "in": "query",
            "minLength": 1,
            "name": "api-version",
            "required": true,
            "type": "string"
          },
          {
            "description": "The ID of the target subscription.",
            "in": "path",
            "minLength": 1,
            "name": "subscriptionId",
            "required": true,
            "type": "string"
          },
          {
            "description": "Optional. Continuation token for the list operation.",
            "in": "query",
            "name": "$skipToken",
            "type": "string"
          },
          {
            "description": "Optional. Specified maximum number of shares that can be included in the list.",
            "in": "query",
            "name": "$maxpagesize",
            "type": "string"
          },
          {
            "description": "Optional. When specified, only share names starting with the filter will be listed.",
            "in": "query",
            "name": "$filter",
            "type": "string"
          }
        ],
        "responses": {
          "200": {
            "description": "OK -- List Shares operation completed successfully.",
            "schema": {
              "$ref": "#/definitions/FileShareItems"
            }
          },
          "default": {
            "description": "Error response describing why the operation failed.",
            "schema": {
              "$ref": "#/definitions/CloudError"
            }
          }
        },
        "tags": [
          "FileShares"
        ],
        "x-ms-examples": {
          "ListShares": {
            "parameters": {
              "accountName": "sto1590",
              "api-version": "2019-04-01",
              "monitor": "true",
              "resourceGroupName": "res9290",
              "subscriptionId": "{subscription-id}"
            },
            "responses": {
              "200": {
                "body": {
                  "nextLink": "https://sto1590endpoint/subscriptions/{subscription-id}/resourceGroups/res9290/providers/Microsoft.Storage/storageAccounts/sto1590/fileServices/default/shares?api-version=2019-04-01&$maxpagesize=2&$skipToken=/sto1590/share5103",
                  "value": [
                    {
                      "etag": "\"0x8D589847D51C7DE\"",
                      "id": "/subscriptions/{subscription-id}/resourceGroups/res9290/providers/Microsoft.Storage/storageAccounts/sto1590/fileServices/default/shares/share1644",
                      "name": "share1644",
                      "properties": {
                        "lastModifiedTime": "2019-05-14T08:20:47Z",
                        "shareQuota": 1024
                      },
                      "type": "Microsoft.Storage/storageAccounts/fileServices/shares"
                    },
                    {
                      "etag": "\"0x8D589847DAB5AF9\"",
                      "id": "/subscriptions/{subscription-id}/resourceGroups/res9290/providers/Microsoft.Storage/storageAccounts/sto1590/fileServices/default/shares/share4052",
                      "name": "share4052",
                      "properties": {
                        "lastModifiedTime": "2019-05-14T08:20:47Z",
                        "shareQuota": 1024
                      },
                      "type": "Microsoft.Storage/storageAccounts/fileServices/shares"
                    }
                  ]
                }
              }
            }
          }
        },
        "x-ms-pageable": {
          "nextLinkName": "nextLink"
        }
      }
    },
    "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/fileServices/default/shares/{shareName}": {
      "delete": {
        "description": "Deletes specified share under its account.",
        "operationId": "FileShares_Delete",
        "parameters": [
          {
            "description": "The name of the resource group within the user's subscription. The name is case insensitive.",
            "in": "path",
            "maxLength": 90,
            "minLength": 1,
            "name": "resourceGroupName",
            "pattern": "^[-\\w\\._\\(\\)]+$",
            "required": true,
            "type": "string",
            "x-ms-parameter-location": "method"
          },
          {
            "description": "The name of the storage account within the specified resource group. Storage account names must be between 3 and 24 characters in length and use numbers and lower-case letters only.",
            "in": "path",
            "maxLength": 24,
            "minLength": 3,
            "name": "accountName",
            "required": true,
            "type": "string",
            "x-ms-parameter-location": "method"
          },
          {
            "$ref": "#/parameters/ShareName"
          },
          {
            "description": "The API version to use for this operation.",
            "in": "query",
            "minLength": 1,
            "name": "api-version",
            "required": true,
            "type": "string"
          },
          {
            "description": "The ID of the target subscription.",
            "in": "path",
            "minLength": 1,
            "name": "subscriptionId",
            "required": true,
            "type": "string"
          }
        ],
        "responses": {
          "200": {
            "description": "OK -- Delete Share operation completed successfully."
          },
          "204": {
            "description": "No Content -- The Share not exist."
          },
          "default": {
            "description": "Error response describing why the operation failed.",
            "schema": {
              "$ref": "#/definitions/CloudError"
            }
          }
        },
        "tags": [
          "FileShares"
        ],
        "x-ms-examples": {
          "DeleteShares": {
            "parameters": {
              "accountName": "sto4506",
              "api-version": "2019-04-01",
              "monitor": "true",
              "resourceGroupName": "res4079",
              "shareName": "share9689",
              "subscriptionId": "{subscription-id}"
            },
            "responses": {
              "200": {},
              "204": {}
            }
          }
        }
      },
      "get": {
        "description": "Gets properties of a specified share.",
        "operationId": "FileShares_Get",
        "parameters": [
          {
            "description": "The name of the resource group within the user's subscription. The name is case insensitive.",
            "in": "path",
            "maxLength": 90,
            "minLength": 1,
            "name": "resourceGroupName",
            "pattern": "^[-\\w\\._\\(\\)]+$",
            "required": true,
            "type": "string",
            "x-ms-parameter-location": "method"
          },
          {
            "description": "The name of the storage account within the specified resource group. Storage account names must be between 3 and 24 characters in length and use numbers and lower-case letters only.",
            "in": "path",
            "maxLength": 24,
            "minLength": 3,
            "name": "accountName",
            "required": true,
            "type": "string",
            "x-ms-parameter-location": "method"
          },
          {
            "$ref": "#/parameters/ShareName"
          },
          {
            "description": "The API version to use for this operation.",
            "in": "query",
            "minLength": 1,
            "name": "api-version",
            "required": true,
            "type": "string"
          },
          {
            "description": "The ID of the target subscription.",
            "in": "path",
            "minLength": 1,
            "name": "subscriptionId",
            "required": true,
            "type": "string"
          }
        ],
        "responses": {
          "200": {
            "description": "OK -- Get Share operation completed successfully.",
            "schema": {
              "$ref": "#/definitions/FileShare"
            }
          },
          "default": {
            "description": "Error response describing why the operation failed.",
            "schema": {
              "$ref": "#/definitions/CloudError"
            }
          }
        },
        "tags": [
          "FileShares"
        ],
        "x-ms-examples": {
          "GetShares": {
            "parameters": {
              "accountName": "sto6217",
              "api-version": "2019-04-01",
              "monitor": "true",
              "resourceGroupName": "res9871",
              "shareName": "share1634",
              "subscriptionId": "{subscription-id}"
            },
            "responses": {
              "200": {
                "body": {
                  "etag": "\"0x8D592D74CC20EBA\"",
                  "id": "/subscriptions/{subscription-id}/resourceGroups/res9871/providers/Microsoft.Storage/storageAccounts/sto6217/fileServices/default/shares/share1634",
                  "name": "share1634",
                  "properties": {
                    "lastModifiedTime": "2019-05-26T05:06:14Z",
                    "shareQuota": 1024
                  },
                  "type": "Microsoft.Storage/storageAccounts/fileServices/shares"
                }
              }
            }
          }
        }
      },
      "patch": {
        "description": "Updates share properties as specified in request body. Properties not mentioned in the request will not be changed. Update fails if the specified share does not already exist. ",
        "operationId": "FileShares_Update",
        "parameters": [
          {
            "description": "The name of the resource group within the user's subscription. The name is case insensitive.",
            "in": "path",
            "maxLength": 90,
            "minLength": 1,
            "name": "resourceGroupName",
            "pattern": "^[-\\w\\._\\(\\)]+$",
            "required": true,
            "type": "string",
            "x-ms-parameter-location": "method"
          },
          {
            "description": "The name of the storage account within the specified resource group. Storage account names must be between 3 and 24 characters in length and use numbers and lower-case letters only.",
            "in": "path",
            "maxLength": 24,
            "minLength": 3,
            "name": "accountName",
            "required": true,
            "type": "string",
            "x-ms-parameter-location": "method"
          },
          {
            "$ref": "#/parameters/ShareName"
          },
          {
            "description": "Properties to update for the file share.",
            "in": "body",
            "name": "fileShare",
            "required": true,
            "schema": {
              "$ref": "#/definitions/FileShare"
            }
          },
          {
            "description": "The API version to use for this operation.",
            "in": "query",
            "minLength": 1,
            "name": "api-version",
            "required": true,
            "type": "string"
          },
          {
            "description": "The ID of the target subscription.",
            "in": "path",
            "minLength": 1,
            "name": "subscriptionId",
            "required": true,
            "type": "string"
          }
        ],
        "responses": {
          "200": {
            "description": "OK -- Update Share operation completed successfully.",
            "schema": {
              "$ref": "#/definitions/FileShare",
              "description": "Properties of the updated file share."
            }
          },
          "default": {
            "description": "Error response describing why the operation failed.",
            "schema": {
              "$ref": "#/definitions/CloudError"
            }
          }
        },
        "tags": [
          "FileShares"
        ],
        "x-ms-examples": {
          "UpdateShares": {
            "parameters": {
              "accountName": "sto328",
              "api-version": "2019-04-01",
              "fileShare": {
                "properties": {
                  "metadata": {
                    "type": "image"
                  }
                }
              },
              "monitor": "true",
              "resourceGroupName": "res3376",
              "shareName": "share6185",
              "subscriptionId": "{subscription-id}"
            },
            "responses": {
              "200": {
                "body": {
                  "id": "/subscriptions/{subscription-id}/resourceGroups/res3376/providers/Microsoft.Storage/storageAccounts/sto328/fileServices/default/shares/share6185",
                  "name": "share6185",
                  "properties": {
                    "metadata": {
                      "type": "image"
                    }
                  },
                  "type": "Microsoft.Storage/storageAccounts/fileServices/shares"
                }
              }
            }
          }
        }
      },
      "put": {
        "description": "Creates a new share under the specified account as described by request body. The share resource includes metadata and properties for that share. It does not include a list of the files contained by the share. ",
        "operationId": "FileShares_Create",
        "parameters": [
          {
            "description": "The name of the resource group within the user's subscription. The name is case insensitive.",
            "in": "path",
            "maxLength": 90,
            "minLength": 1,
            "name": "resourceGroupName",
            "pattern": "^[-\\w\\._\\(\\)]+$",
            "required": true,
            "type": "string",
            "x-ms-parameter-location": "method"
          },
          {
            "description": "The name of the storage account within the specified resource group. Storage account names must be between 3 and 24 characters in length and use numbers and lower-case letters only.",
            "in": "path",
            "maxLength": 24,
            "minLength": 3,
            "name": "accountName",
            "required": true,
            "type": "string",
            "x-ms-parameter-location": "method"
          },
          {
            "$ref": "#/parameters/ShareName"
          },
          {
            "description": "Properties of the file share to create.",
            "in": "body",
            "name": "fileShare",
            "required": true,
            "schema": {
              "$ref": "#/definitions/FileShare"
            }
          },
          {
            "description": "The API version to use for this operation.",
            "in": "query",
            "minLength": 1,
            "name": "api-version",
            "required": true,
            "type": "string"
          },
          {
            "description": "The ID of the target subscription.",
            "in": "path",
            "minLength": 1,
            "name": "subscriptionId",
            "required": true,
            "type": "string"
          }
        ],
        "responses": {
          "200": {
            "description": "OK -- The Share is already created.",
            "schema": {
              "$ref": "#/definitions/FileShare"
            }
          },
          "201": {
            "description": "Created -- Create Share operation completed successfully.",
            "schema": {
              "$ref": "#/definitions/FileShare"
            }
          },
          "default": {
            "description": "Error response describing why the operation failed.",
            "schema": {
              "$ref": "#/definitions/CloudError"
            }
          }
        },
        "tags": [
          "FileShares"
        ],
        "x-ms-examples": {
          "PutShares": {
            "parameters": {
              "accountName": "sto328",
              "api-version": "2019-04-01",
              "fileShare": {},
              "monitor": "true",
              "resourceGroupName": "res3376",
              "shareName": "share6185",
              "subscriptionId": "{subscription-id}"
            },
            "responses": {
              "200": {
                "body": {
                  "id": "/subscriptions/{subscription-id}/resourceGroups/res3376/providers/Microsoft.Storage/storageAccounts/sto328/fileServices/default/shares/share6185",
                  "name": "share6185",
                  "type": "Microsoft.Storage/storageAccounts/fileServices/shares"
                }
              },
              "201": {
                "body": {
                  "id": "/subscriptions/{subscription-id}/resourceGroups/res3376/providers/Microsoft.Storage/storageAccounts/sto328/fileServices/default/shares/share6185",
                  "name": "share6185",
                  "type": "Microsoft.Storage/storageAccounts/fileServices/shares"
                }
              }
            }
          }
        }
      }
    },
    "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/fileServices/{FileServicesName}": {
      "get": {
        "description": "Gets the properties of file services in storage accounts, including CORS (Cross-Origin Resource Sharing) rules.",
        "operationId": "FileServices_GetServiceProperties",
        "parameters": [
          {
            "description": "The name of the resource group within the user's subscription. The name is case insensitive.",
            "in": "path",
            "maxLength": 90,
            "minLength": 1,
            "name": "resourceGroupName",
            "pattern": "^[-\\w\\._\\(\\)]+$",
            "required": true,
            "type": "string",
            "x-ms-parameter-location": "method"
          },
          {
            "description": "The name of the storage account within the specified resource group. Storage account names must be between 3 and 24 characters in length and use numbers and lower-case letters only.",
            "in": "path",
            "maxLength": 24,
            "minLength": 3,
            "name": "accountName",
            "required": true,
            "type": "string",
            "x-ms-parameter-location": "method"
          },
          {
            "description": "The API version to use for this operation.",
            "in": "query",
            "minLength": 1,
            "name": "api-version",
            "required": true,
            "type": "string"
          },
          {
            "description": "The ID of the target subscription.",
            "in": "path",
            "minLength": 1,
            "name": "subscriptionId",
            "required": true,
            "type": "string"
          },
          {
            "$ref": "#/parameters/FileServicesName"
          }
        ],
        "responses": {
          "200": {
            "description": "OK -- returned the properties of a storage account’s File service.",
            "schema": {
              "$ref": "#/definitions/FileServiceProperties"
            }
          },
          "default": {
            "description": "Error response describing why the operation failed.",
            "schema": {
              "$ref": "#/definitions/CloudError"
            }
          }
        },
        "tags": [
          "FileService"
        ],
        "x-ms-examples": {
          "GetFileServices": {
            "parameters": {
              "FileServicesName": "default",
              "accountName": "sto8607",
              "api-version": "2019-04-01",
              "monitor": "true",
              "resourceGroupName": "res4410",
              "subscriptionId": "{subscription-id}"
            },
            "responses": {
              "200": {
                "body": {
                  "id": "/subscriptions/{subscription-id}/resourceGroups/res4410/providers/Microsoft.Storage/storageAccounts/sto8607/fileServices/default",
                  "name": "default",
                  "properties": {
                    "cors": {
                      "corsRules": [
                        {
                          "allowedHeaders": [
                            "x-ms-meta-abc",
                            "x-ms-meta-data*",
                            "x-ms-meta-target*"
                          ],
                          "allowedMethods": [
                            "GET",
                            "HEAD",
                            "POST",
                            "OPTIONS",
                            "MERGE",
                            "PUT"
                          ],
                          "allowedOrigins": [
                            "http://www.contoso.com",
                            "http://www.fabrikam.com"
                          ],
                          "exposedHeaders": [
                            "x-ms-meta-*"
                          ],
                          "maxAgeInSeconds": 100
                        },
                        {
                          "allowedHeaders": [
                            "*"
                          ],
                          "allowedMethods": [
                            "GET"
                          ],
                          "allowedOrigins": [
                            "*"
                          ],
                          "exposedHeaders": [
                            "*"
                          ],
                          "maxAgeInSeconds": 2
                        },
                        {
                          "allowedHeaders": [
                            "x-ms-meta-12345675754564*"
                          ],
                          "allowedMethods": [
                            "GET",
                            "PUT"
                          ],
                          "allowedOrigins": [
                            "http://www.abc23.com",
                            "https://www.fabrikam.com/*"
                          ],
                          "exposedHeaders": [
                            "x-ms-meta-abc",
                            "x-ms-meta-data*",
                            "x-ms-meta-target*"
                          ],
                          "maxAgeInSeconds": 2000
                        }
                      ]
                    }
                  },
                  "type": "Microsoft.Storage/storageAccounts/fileServices"
                }
              }
            }
          }
        }
      },
      "put": {
        "description": "Sets the properties of file services in storage accounts, including CORS (Cross-Origin Resource Sharing) rules. ",
        "operationId": "FileServices_SetServiceProperties",
        "parameters": [
          {
            "description": "The name of the resource group within the user's subscription. The name is case insensitive.",
            "in": "path",
            "maxLength": 90,
            "minLength": 1,
            "name": "resourceGroupName",
            "pattern": "^[-\\w\\._\\(\\)]+$",
            "required": true,
            "type": "string",
            "x-ms-parameter-location": "method"
          },
          {
            "description": "The name of the storage account within the specified resource group. Storage account names must be between 3 and 24 characters in length and use numbers and lower-case letters only.",
            "in": "path",
            "maxLength": 24,
            "minLength": 3,
            "name": "accountName",
            "required": true,
            "type": "string",
            "x-ms-parameter-location": "method"
          },
          {
            "description": "The API version to use for this operation.",
            "in": "query",
            "minLength": 1,
            "name": "api-version",
            "required": true,
            "type": "string"
          },
          {
            "description": "The ID of the target subscription.",
            "in": "path",
            "minLength": 1,
            "name": "subscriptionId",
            "required": true,
            "type": "string"
          },
          {
            "$ref": "#/parameters/FileServicesName"
          },
          {
            "description": "The properties of file services in storage accounts, including CORS (Cross-Origin Resource Sharing) rules.",
            "in": "body",
            "name": "parameters",
            "required": true,
            "schema": {
              "$ref": "#/definitions/FileServiceProperties"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK -- Sets The properties of a storage account’s File service successfully.",
            "schema": {
              "$ref": "#/definitions/FileServiceProperties"
            }
          },
          "default": {
            "description": "Error response describing why the operation failed.",
            "schema": {
              "$ref": "#/definitions/CloudError"
            }
          }
        },
        "tags": [
          "FileService"
        ],
        "x-ms-examples": {
          "PutFileServices": {
            "parameters": {
              "FileServicesName": "default",
              "accountName": "sto8607",
              "api-version": "2019-04-01",
              "monitor": "true",
              "parameters": {
                "properties": {
                  "cors": {
                    "corsRules": [
                      {
                        "allowedHeaders": [
                          "x-ms-meta-abc",
                          "x-ms-meta-data*",
                          "x-ms-meta-target*"
                        ],
                        "allowedMethods": [
                          "GET",
                          "HEAD",
                          "POST",
                          "OPTIONS",
                          "MERGE",
                          "PUT"
                        ],
                        "allowedOrigins": [
                          "http://www.contoso.com",
                          "http://www.fabrikam.com"
                        ],
                        "exposedHeaders": [
                          "x-ms-meta-*"
                        ],
                        "maxAgeInSeconds": 100
                      },
                      {
                        "allowedHeaders": [
                          "*"
                        ],
                        "allowedMethods": [
                          "GET"
                        ],
                        "allowedOrigins": [
                          "*"
                        ],
                        "exposedHeaders": [
                          "*"
                        ],
                        "maxAgeInSeconds": 2
                      },
                      {
                        "allowedHeaders": [
                          "x-ms-meta-12345675754564*"
                        ],
                        "allowedMethods": [
                          "GET",
                          "PUT"
                        ],
                        "allowedOrigins": [
                          "http://www.abc23.com",
                          "https://www.fabrikam.com/*"
                        ],
                        "exposedHeaders": [
                          "x-ms-meta-abc",
                          "x-ms-meta-data*",
                          "x-ms-meta-target*"
                        ],
                        "maxAgeInSeconds": 2000
                      }
                    ]
                  }
                }
              },
              "resourceGroupName": "res4410",
              "subscriptionId": "{subscription-id}"
            },
            "responses": {
              "200": {
                "body": {
                  "id": "/subscriptions/{subscription-id}/resourceGroups/res4410/providers/Microsoft.Storage/storageAccounts/sto8607/fileServices/default",
                  "name": "default",
                  "properties": {
                    "cors": {
                      "corsRules": [
                        {
                          "allowedHeaders": [
                            "x-ms-meta-abc",
                            "x-ms-meta-data*",
                            "x-ms-meta-target*"
                          ],
                          "allowedMethods": [
                            "GET",
                            "HEAD",
                            "POST",
                            "OPTIONS",
                            "MERGE",
                            "PUT"
                          ],
                          "allowedOrigins": [
                            "http://www.contoso.com",
                            "http://www.fabrikam.com"
                          ],
                          "exposedHeaders": [
                            "x-ms-meta-*"
                          ],
                          "maxAgeInSeconds": 100
                        },
                        {
                          "allowedHeaders": [
                            "*"
                          ],
                          "allowedMethods": [
                            "GET"
                          ],
                          "allowedOrigins": [
                            "*"
                          ],
                          "exposedHeaders": [
                            "*"
                          ],
                          "maxAgeInSeconds": 2
                        },
                        {
                          "allowedHeaders": [
                            "x-ms-meta-12345675754564*"
                          ],
                          "allowedMethods": [
                            "GET",
                            "PUT"
                          ],
                          "allowedOrigins": [
                            "http://www.abc23.com",
                            "https://www.fabrikam.com/*"
                          ],
                          "exposedHeaders": [
                            "x-ms-meta-abc",
                            "x-ms-meta-data*",
                            "x-ms-meta-target*"
                          ],
                          "maxAgeInSeconds": 2000
                        }
                      ]
                    }
                  },
                  "type": "Microsoft.Storage/storageAccounts/fileServices"
                }
              }
            }
          }
        }
      }
    }
  },
  "definitions": {
    "CloudError": {
      "description": "An error response from the Storage service.",
      "properties": {
        "error": {
          "$ref": "#/definitions/CloudErrorBody"
        }
      },
      "x-ms-external": true
    },
    "CloudErrorBody": {
      "description": "An error response from the Storage service.",
      "properties": {
        "code": {
          "description": "An identifier for the error. Codes are invariant and are intended to be consumed programmatically.",
          "type": "string"
        },
        "details": {
          "description": "A list of additional details about the error.",
          "items": {
            "$ref": "#/definitions/CloudErrorBody"
          },
          "type": "array"
        },
        "message": {
          "description": "A message describing the error, intended to be suitable for display in a user interface.",
          "type": "string"
        },
        "target": {
          "description": "The target of the particular error. For example, the name of the property in error.",
          "type": "string"
        }
      },
      "x-ms-external": true
    },
    "FileServiceItems": {
      "properties": {
        "value": {
          "description": "List of file services returned.",
          "items": {
            "$ref": "#/definitions/FileServiceProperties"
          },
          "readOnly": true,
          "type": "array"
        }
      }
    },
    "FileServiceProperties": {
      "allOf": [
        {
          "properties": {
            "id": {
              "description": "Fully qualified resource Id for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}",
              "readOnly": true,
              "type": "string"
            },
            "name": {
              "description": "The name of the resource",
              "readOnly": true,
              "type": "string"
            },
            "type": {
              "description": "The type of the resource. Ex- Microsoft.Compute/virtualMachines or Microsoft.Storage/storageAccounts.",
              "readOnly": true,
              "type": "string"
            }
          },
          "x-ms-azure-resource": true
        }
      ],
      "description": "The properties of File services in storage account.",
      "properties": {
        "properties": {
          "description": "The properties of File services in storage account.",
          "properties": {
            "cors": {
              "description": "Sets the CORS rules. You can include up to five CorsRule elements in the request. ",
              "properties": {
                "corsRules": {
                  "description": "The List of CORS rules. You can include up to five CorsRule elements in the request. ",
                  "items": {
                    "description": "Specifies a CORS rule for the Blob service.",
                    "properties": {
                      "allowedHeaders": {
                        "description": "Required if CorsRule element is present. A list of headers allowed to be part of the cross-origin request.",
                        "items": {
                          "type": "string"
                        },
                        "type": "array"
                      },
                      "allowedMethods": {
                        "description": "Required if CorsRule element is present. A list of HTTP methods that are allowed to be executed by the origin.",
                        "items": {
                          "enum": [
                            "DELETE",
                            "GET",
                            "HEAD",
                            "MERGE",
                            "POST",
                            "OPTIONS",
                            "PUT"
                          ],
                          "type": "string"
                        },
                        "type": "array"
                      },
                      "allowedOrigins": {
                        "description": "Required if CorsRule element is present. A list of origin domains that will be allowed via CORS, or \"*\" to allow all domains",
                        "items": {
                          "type": "string"
                        },
                        "type": "array"
                      },
                      "exposedHeaders": {
                        "description": "Required if CorsRule element is present. A list of response headers to expose to CORS clients.",
                        "items": {
                          "type": "string"
                        },
                        "type": "array"
                      },
                      "maxAgeInSeconds": {
                        "description": "Required if CorsRule element is present. The number of seconds that the client/browser should cache a preflight response.",
                        "type": "integer"
                      }
                    },
                    "required": [
                      "allowedOrigins",
                      "allowedMethods",
                      "maxAgeInSeconds",
                      "exposedHeaders",
                      "allowedHeaders"
                    ]
                  },
                  "type": "array"
                }
              }
            }
          },
          "x-ms-client-flatten": true,
          "x-ms-client-name": "FileServiceProperties"
        }
      }
    },
    "FileShare": {
      "allOf": [
        {
          "allOf": [
            {
              "properties": {
                "id": {
                  "description": "Fully qualified resource Id for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}",
                  "readOnly": true,
                  "type": "string"
                },
                "name": {
                  "description": "The name of the resource",
                  "readOnly": true,
                  "type": "string"
                },
                "type": {
                  "description": "The type of the resource. Ex- Microsoft.Compute/virtualMachines or Microsoft.Storage/storageAccounts.",
                  "readOnly": true,
                  "type": "string"
                }
              },
              "x-ms-azure-resource": true
            }
          ],
          "description": "The resource model definition for a Azure Resource Manager resource with an etag.",
          "properties": {
            "etag": {
              "description": "Resource Etag.",
              "readOnly": true,
              "type": "string"
            }
          },
          "x-ms-client-name": "AzureEntityResource"
        }
      ],
      "description": "Properties of the file share, including Id, resource name, resource type, Etag.",
      "properties": {
        "properties": {
          "$ref": "#/definitions/FileShareProperties",
          "description": "Properties of the file share.",
          "x-ms-client-flatten": true,
          "x-ms-client-name": "FileShareProperties"
        }
      }
    },
    "FileShareItem": {
      "allOf": [
        {
          "allOf": [
            {
              "properties": {
                "id": {
                  "description": "Fully qualified resource Id for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}",
                  "readOnly": true,
                  "type": "string"
                },
                "name": {
                  "description": "The name of the resource",
                  "readOnly": true,
                  "type": "string"
                },
                "type": {
                  "description": "The type of the resource. Ex- Microsoft.Compute/virtualMachines or Microsoft.Storage/storageAccounts.",
                  "readOnly": true,
                  "type": "string"
                }
              },
              "x-ms-azure-resource": true
            }
          ],
          "description": "The resource model definition for a Azure Resource Manager resource with an etag.",
          "properties": {
            "etag": {
              "description": "Resource Etag.",
              "readOnly": true,
              "type": "string"
            }
          },
          "x-ms-client-name": "AzureEntityResource"
        }
      ],
      "description": "The file share properties be listed out.",
      "properties": {
        "properties": {
          "$ref": "#/definitions/FileShareProperties",
          "description": "The file share properties be listed out.",
          "x-ms-client-flatten": true
        }
      }
    },
    "FileShareItems": {
      "description": "Response schema. Contains list of shares returned, and if paging is requested or required, a URL to next page of shares.",
      "properties": {
        "nextLink": {
          "description": "Request URL that can be used to query next page of shares. Returned when total number of requested shares exceed maximum page size.",
          "readOnly": true,
          "type": "string"
        },
        "value": {
          "description": "List of file shares returned.",
          "items": {
            "$ref": "#/definitions/FileShareItem"
          },
          "readOnly": true,
          "type": "array"
        }
      }
    },
    "FileShareProperties": {
      "description": "The properties of the file share.",
      "properties": {
        "lastModifiedTime": {
          "description": "Returns the date and time the share was last modified.",
          "format": "date-time",
          "readOnly": true,
          "type": "string"
        },
        "metadata": {
          "additionalProperties": {
            "type": "string"
          },
          "description": "A name-value pair to associate with the share as metadata.",
          "type": "object"
        },
        "shareQuota": {
          "description": "The maximum size of the share, in gigabytes. Must be greater than 0, and less than or equal to 5TB (5120).",
          "maximum": 5120,
          "minimum": 1,
          "type": "integer"
        }
      }
    }
  }
}